/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Fast.xs. Do not edit this file, edit Fast.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Fast.xs"
/*
  Copyright (C) 2007-2010 Tomash Brechko.  All rights reserved.

  This library is free software; you can redistribute it and/or modify
  it under the same terms as Perl itself, either Perl version 5.8.8
  or, at your option, any later version of Perl 5 you may have
  available.
*/

#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "src/client.h"
#include <stdlib.h>
#include <string.h>


#define F_STORABLE  0x1
#define F_COMPRESS  0x2
#define F_UTF8      0x4


struct xs_state
{
  struct client *c;
  AV *servers;
  int compress_threshold;
  double compress_ratio;
  SV *compress_method;
  SV *decompress_method;
  SV *serialize_method;
  SV *deserialize_method;
  int utf8;
  size_t max_size;
};

typedef struct xs_state Cache_Memcached_Fast;

static inline
SV**
safe_av_fetch(pTHX_ AV *av, SSize_t key, I32 lval)
{
  SV ** v = av_fetch(av, key, lval);
  if ( !v || !SvOK(*v) )
    croak("undefined value passed to av_fetch");

  return v;
}

static
void
add_server(pTHX_ Cache_Memcached_Fast *memd, SV *addr_sv,
           double weight, int noreply)
{
  struct client *c = memd->c;
  static const int delim = ':';
  const char *host, *port;
  size_t host_len, port_len;
  STRLEN len;
  int res;

  av_push(memd->servers, newSVsv(addr_sv));

  if (weight <= 0.0)
    croak("Server weight should be positive");

  host = SvPV(addr_sv, len);
  /*
    NOTE: here we relay on the fact that host is zero-terminated.
  */
  port = strrchr(host, delim);
  if (port)
    {
      host_len = port - host;
      ++port;
      port_len = len - host_len - 1;
      res = client_add_server(c, host, host_len, port, port_len,
                              weight, noreply);
    }
  else
    {
      res = client_add_server(c, host, len, NULL, 0, weight, noreply);
    }
  if (res != MEMCACHED_SUCCESS)
    croak("Not enough memory");
}


static
void
parse_server(pTHX_ Cache_Memcached_Fast *memd, SV *sv)
{
  if (! SvROK(sv))
    {
      add_server(aTHX_ memd, sv, 1.0, 0);
    }
  else
    {
      switch (SvTYPE(SvRV(sv)))
        {
        case SVt_PVHV:
          {
            HV *hv = (HV *) SvRV(sv);
            SV **addr_sv, **ps;
            double weight = 1.0;
            int noreply = 0;

            addr_sv = hv_fetch(hv, "address", 7, 0);
            if (addr_sv)
              SvGETMAGIC(*addr_sv);
            else
              croak("server should have { address => $addr }");
            ps = hv_fetch(hv, "weight", 6, 0);
            if (ps)
              SvGETMAGIC(*ps);
            if (ps && SvOK(*ps))
              weight = SvNV(*ps);
            ps = hv_fetch(hv, "noreply", 7, 0);
            if (ps)
              SvGETMAGIC(*ps);
            if (ps && SvOK(*ps))
              noreply = SvTRUE(*ps);
            add_server(aTHX_ memd, *addr_sv, weight, noreply);
          }
          break;

        case SVt_PVAV:
          {
            AV *av = (AV *) SvRV(sv);
            SV **addr_sv, **weight_sv;
            double weight = 1.0;

            addr_sv = av_fetch(av, 0, 0);
            if (addr_sv)
              SvGETMAGIC(*addr_sv);
            else
              croak("server should be [$addr, $weight]");
            weight_sv = av_fetch(av, 1, 0);
            if (weight_sv)
              weight = SvNV(*weight_sv);
            add_server(aTHX_ memd, *addr_sv, weight, 0);
          }
          break;

        default:
          croak("Not a hash or array reference");
          break;
        }
    }
}


static
void
parse_serialize(pTHX_ Cache_Memcached_Fast *memd, HV *conf)
{
  SV **ps;

  memd->utf8 = 0;
  memd->serialize_method = NULL;
  memd->deserialize_method = NULL;

  ps = hv_fetch(conf, "utf8", 4, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->utf8 = SvTRUE(*ps);

  ps = hv_fetch(conf, "serialize_methods", 17, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *av = (AV *) SvRV(*ps);
      memd->serialize_method = newSVsv(*safe_av_fetch(aTHX_ av, 0, 0));
      memd->deserialize_method = newSVsv(*safe_av_fetch(aTHX_ av, 1, 0));
    }

  if (! memd->serialize_method)
    croak("Serialize method is not specified");

  if (! memd->deserialize_method)
    croak("Deserialize method is not specified");
}


static
void
parse_compress(pTHX_ Cache_Memcached_Fast *memd, HV *conf)
{
  SV **ps;

  memd->compress_threshold = -1;
  memd->compress_ratio = 0.8;
  memd->compress_method = NULL;
  memd->decompress_method = NULL;

  ps = hv_fetch(conf, "compress_threshold", 18, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->compress_threshold = SvIV(*ps);

  ps = hv_fetch(conf, "compress_ratio", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->compress_ratio = SvNV(*ps);

  ps = hv_fetch(conf, "compress_methods", 16, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *av = (AV *) SvRV(*ps);
      memd->compress_method = newSVsv(*safe_av_fetch(aTHX_ av, 0, 0));
      memd->decompress_method = newSVsv(*safe_av_fetch(aTHX_ av, 1, 0));
    }
  else if (memd->compress_threshold > 0)
    {
      warn("Compression module was not found, disabling compression");
      memd->compress_threshold = -1;
    }
}


static
void
parse_config(pTHX_ Cache_Memcached_Fast *memd, HV *conf)
{
  struct client *c = memd->c;
  SV **ps;

  memd->servers = newAV();

  ps = hv_fetch(conf, "ketama_points", 13, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      int res = client_set_ketama_points(c, SvIV(*ps));
      if (res != MEMCACHED_SUCCESS)
        croak("client_set_ketama() failed");
    }

  ps = hv_fetch(conf, "hash_namespace", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_hash_namespace(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "servers", 7, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      AV *a;
      int max_index, i;

      if (! SvROK(*ps) || SvTYPE(SvRV(*ps)) != SVt_PVAV)
        croak("Not an array reference");
      a = (AV *) SvRV(*ps);
      max_index = av_len(a);
      for (i = 0; i <= max_index; ++i)
        {
          ps = av_fetch(a, i, 0);
          if (! ps)
            continue;

          SvGETMAGIC(*ps);
          parse_server(aTHX_ memd, *ps);
        }
    }

  ps = hv_fetch(conf, "namespace", 9, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    {
      const char *ns;
      STRLEN len;
      ns = SvPV(*ps, len);
      if (client_set_prefix(c, ns, len) != MEMCACHED_SUCCESS)
        croak("Not enough memory");
    }

  ps = hv_fetch(conf, "connect_timeout", 15, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_connect_timeout(c, SvNV(*ps) * 1000.0);

  ps = hv_fetch(conf, "io_timeout", 10, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_io_timeout(c, SvNV(*ps) * 1000.0);

  /* For compatibility with Cache::Memcached.  */
  ps = hv_fetch(conf, "select_timeout", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_io_timeout(c, SvNV(*ps) * 1000.0);

  ps = hv_fetch(conf, "max_failures", 12, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_max_failures(c, SvIV(*ps));

  ps = hv_fetch(conf, "failure_timeout", 15, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_failure_timeout(c, SvIV(*ps));

  ps = hv_fetch(conf, "close_on_error", 14, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_close_on_error(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "nowait", 6, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    client_set_nowait(c, SvTRUE(*ps));

  ps = hv_fetch(conf, "max_size", 8, 0);
  if (ps)
    SvGETMAGIC(*ps);
  if (ps && SvOK(*ps))
    memd->max_size = SvUV(*ps);
  else
    memd->max_size = 1024 * 1024;

  parse_compress(aTHX_ memd, conf);
  parse_serialize(aTHX_ memd, conf);
}


static inline
SV *
compress(pTHX_ Cache_Memcached_Fast *memd, SV *sv, flags_type *flags)
{
  if (memd->compress_threshold > 0)
    {
      STRLEN len = sv_len(sv);
      SV *csv, *bsv;
      int count;
      dSP;

      if (len < (STRLEN) memd->compress_threshold)
        return sv;

      csv = newSV(0);

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(newRV_inc(sv)));
      XPUSHs(sv_2mortal(newRV_noinc(csv)));
      PUTBACK;

      count = call_sv(memd->compress_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Compress method returned nothing");

      bsv = POPs;
      if (SvTRUE(bsv) && sv_len(csv) <= len * memd->compress_ratio)
        {
          sv = csv;
          *flags |= F_COMPRESS;
        }

      PUTBACK;
    }

  return sv;
}


static inline
int
decompress(pTHX_ Cache_Memcached_Fast *memd, SV **sv, flags_type flags)
{
  int res = 1;

  if (flags & F_COMPRESS)
    {
      SV *rsv, *bsv;
      int count;
      dSP;

      rsv = newSV(0);

      PUSHMARK(SP);
      XPUSHs(sv_2mortal(newRV_inc(*sv)));
      XPUSHs(sv_2mortal(newRV_inc(rsv)));
      PUTBACK;

      count = call_sv(memd->decompress_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Decompress method returned nothing");

      bsv = POPs;
      if (SvTRUE(bsv))
        {
          SvREFCNT_dec(*sv);
          *sv = rsv;
        }
      else
        {
          SvREFCNT_dec(rsv);
          res = 0;
        }

      PUTBACK;
    }

  return res;
}


static inline
SV *
serialize(pTHX_ Cache_Memcached_Fast *memd, SV *sv, flags_type *flags)
{
  if (SvROK(sv))
    {
      int count;
      dSP;

      PUSHMARK(SP);
      XPUSHs(sv);
      PUTBACK;

      count = call_sv(memd->serialize_method, G_SCALAR);

      SPAGAIN;

      if (count != 1)
        croak("Serialize method returned nothing");

      sv = POPs;
      *flags |= F_STORABLE;

      PUTBACK;
    }
  else if (SvUTF8(sv))
    {
      /* Copy the value because we will modify it in place.  */
      sv = sv_2mortal(newSVsv(sv));
      if (memd->utf8)
        {
          sv_utf8_encode(sv);
          *flags |= F_UTF8;
        }
      else
        {
          sv_utf8_downgrade(sv, 0);
        }
    }

  return sv;
}


static inline
int
deserialize(pTHX_ Cache_Memcached_Fast *memd, SV **sv, flags_type flags)
{
  int res = 1;

  if (flags & F_STORABLE)
    {
      SV *rsv;
      int count;
      dSP;

      PUSHMARK(SP);
      XPUSHs(*sv);
      PUTBACK;

      /* FIXME: do we need G_KEPEERR here?  */
      count = call_sv(memd->deserialize_method, G_SCALAR | G_EVAL);

      SPAGAIN;

      if (count != 1)
        croak("Deserialize method returned nothing");

      rsv = POPs;
      if (! SvTRUE(ERRSV))
        {
          SvREFCNT_dec(*sv);
          *sv = SvREFCNT_inc(rsv);
        }
      else
        {
          res = 0;
        }

      PUTBACK;
    }
  else if ((flags & F_UTF8) && memd->utf8)
    {
      res = sv_utf8_decode(*sv);
    }
   
  return res;
}


static
void *
alloc_value(value_size_type value_size, void **opaque)
{
  dTHX;
  SV *sv;
  char *res;

  sv = newSVpvn("", 0);
  res = SvGROW(sv, value_size + 1); /* FIXME: check OOM.  */
  res[value_size] = '\0';
  SvCUR_set(sv, value_size);

  *opaque = sv;

  return (void *) res;
}


static
void
free_value(void *opaque)
{
  dTHX;
  SV *sv = (SV *) opaque;

  SvREFCNT_dec(sv);
}


struct xs_value_result
{
  Cache_Memcached_Fast *memd;  
  SV *vals;
};


static
void
svalue_store(void *arg, void *opaque, int key_index, void *meta)
{
  dTHX;
  SV *value_sv = (SV *) opaque;
  struct xs_value_result *value_res = (struct xs_value_result *) arg;
  struct meta_object *m = (struct meta_object *) meta;

  /* Suppress warning about unused key_index.  */
  if (key_index) {}

  if (! decompress(aTHX_ value_res->memd, &value_sv, m->flags)
      || ! deserialize(aTHX_ value_res->memd, &value_sv, m->flags))
    {
      free_value(value_sv);
      return;
    }

  if (! m->use_cas)
    {
      value_res->vals = value_sv;
    }
  else
    {
      AV *cas_val = newAV();
      av_extend(cas_val, 1);
      av_push(cas_val, newSVuv(m->cas));
      av_push(cas_val, value_sv);
      value_res->vals = newRV_noinc((SV *) cas_val);
    }
}


static
void
mvalue_store(void *arg, void *opaque, int key_index, void *meta)
{
  dTHX;
  SV *value_sv = (SV *) opaque;
  struct xs_value_result *value_res = (struct xs_value_result *) arg;
  struct meta_object *m = (struct meta_object *) meta;

  if (! decompress(aTHX_ value_res->memd, &value_sv, m->flags)
      || ! deserialize(aTHX_ value_res->memd, &value_sv, m->flags))
    {
      free_value(value_sv);
      return;
    }

  if (! m->use_cas)
    {
      av_store((AV *) value_res->vals, key_index, value_sv);
    }
  else
    {
      AV *cas_val = newAV();
      av_extend(cas_val, 1);
      av_push(cas_val, newSVuv(m->cas));
      av_push(cas_val, value_sv);
      av_store((AV *) value_res->vals, key_index, newRV_noinc((SV *) cas_val));
    }
}


static
void
result_store(void *arg, void *opaque, int key_index, void *meta)
{
  dTHX;
  AV *av = (AV *) arg;
  int res = (ptrdiff_t) opaque;

  /* Suppress warning about unused meta.  */
  if (meta) {}

  if (res)
    av_store(av, key_index, newSViv(res));
  else
    av_store(av, key_index, newSVpvn("", 0));
}


static
void
embedded_store(void *arg, void *opaque, int key_index, void *meta)
{
  dTHX;
  AV *av = (AV *) arg;
  SV *sv = (SV *) opaque;

  /* Suppress warning about unused meta.  */
  if (meta) {}

  av_store(av, key_index, sv);
}


/*
  When SvPV() is called on a magic SV the result of mg_get() is cached
  in PV slot.  Since we pass around pointers to this storage we have
  to avoid value refetch and reallocation that would happen if
  mg_get() is called again.  Because any magic SV may be put to the
  argument list more than once we create a temporal copies of them,
  thus braking possible ties and ensuring that every argument is
  fetched exactly once.
*/
static inline
char *
SvPV_stable_storage(pTHX_ SV *sv, STRLEN *lp)
{
  if (SvGAMAGIC(sv))
    sv = sv_2mortal(newSVsv(sv));

  return SvPV(sv, *lp);
}


#line 689 "Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 833 "Fast.c"

XS_EUPXS(XS_Cache__Memcached__Fast__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast__new)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "class, conf");
    {
	char *	class = (char *)SvPV_nolen(ST(0))
;
	SV *	conf = ST(1)
;
#line 688 "Fast.xs"
        Cache_Memcached_Fast *memd;
#line 848 "Fast.c"
	Cache_Memcached_Fast *	RETVAL;
#line 690 "Fast.xs"
        memd = (Cache_Memcached_Fast *) malloc(sizeof(Cache_Memcached_Fast));
        memd->c = client_init();
        if (! memd->c)
          croak("Not enough memory");
        if (! SvROK(conf) || SvTYPE(SvRV(conf)) != SVt_PVHV)
          croak("Not a hash reference");
        parse_config(aTHX_ memd, (HV *) SvRV(conf));
        RETVAL = memd;
#line 859 "Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, class, (void*) RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cache__Memcached__Fast__destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast__destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 707 "Fast.xs"
        client_destroy(memd->c);
        if (memd->compress_method)
          {
            SvREFCNT_dec(memd->compress_method);
            SvREFCNT_dec(memd->decompress_method);
          }
        if (memd->serialize_method)
          {
            SvREFCNT_dec(memd->serialize_method);
            SvREFCNT_dec(memd->deserialize_method);
          }
        SvREFCNT_dec(memd->servers);
        free(memd);
#line 906 "Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Cache__Memcached__Fast_enable_compress); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_enable_compress)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "memd, enable");
    {
	Cache_Memcached_Fast *	memd;
	bool	enable = (bool)SvTRUE(ST(1))
;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 728 "Fast.xs"
        if (enable && ! memd->compress_method)
          warn("Compression module was not found, can't enable compression");
        else if ((memd->compress_threshold > 0) != enable)
          memd->compress_threshold = -memd->compress_threshold;
#line 940 "Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Cache__Memcached__Fast_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 745 "Fast.xs"
        int noreply;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        const char *key;
        STRLEN key_len;
        cas_type cas = 0;
        const void *buf;
        STRLEN buf_len;
        flags_type flags = 0;
        exptime_type exptime = 0;
        int arg = 1;
        SV *sv;
#line 970 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 758 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV_stable_storage(aTHX_ ST(arg), &key_len);
        ++arg;
        if (ix == CMD_CAS)
          {
            cas = SvUV(ST(arg));
            ++arg;
          }
        sv = ST(arg);
        ++arg;
        sv = serialize(aTHX_ memd, sv, &flags);
        sv = compress(aTHX_ memd, sv, &flags);
        buf = (void *) SvPV_stable_storage(aTHX_ sv, &buf_len);
        if (buf_len > memd->max_size)
          XSRETURN_EMPTY;
        if (items > arg)
          {
            /* exptime doesn't have to be defined.  */
            sv = ST(arg);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              exptime = SvIV(sv);
          }
        if (ix != CMD_CAS)
          {
            client_prepare_set(memd->c, ix, 0, key, key_len, flags,
                               exptime, buf, buf_len);
          }
        else
          {
            client_prepare_cas(memd->c, 0, key, key_len, cas, flags,
                               exptime, buf, buf_len);
          }
        client_execute(memd->c, 2);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
            XSRETURN_EMPTY;
          }
#line 1032 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_set_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_set_multi)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 818 "Fast.xs"
        int i, noreply;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
#line 1054 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 822 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            AV *av;
            const char *key;
            STRLEN key_len;
            /*
              gcc-3.4.2 gives a warning about possibly uninitialized
              cas, so we set it to zero.
            */
            cas_type cas = 0;
            const void *buf;
            STRLEN buf_len;
            flags_type flags = 0;
            exptime_type exptime = 0;
            int arg = 0;

            sv = ST(i);
            if (! (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV))
              croak("Not an array reference");

            av = (AV *) SvRV(sv);
            key = SvPV_stable_storage(aTHX_ *safe_av_fetch(aTHX_ av, arg, 0), &key_len);
            ++arg;
            if (ix == CMD_CAS)
              {
                cas = SvUV(*safe_av_fetch(aTHX_ av, arg, 0));
                ++arg;
              }
            sv = *safe_av_fetch(aTHX_ av, arg, 0);
            ++arg;
            sv = serialize(aTHX_ memd, sv, &flags);
            sv = compress(aTHX_ memd, sv, &flags);
            buf = (void *) SvPV_stable_storage(aTHX_ sv, &buf_len);
            if (buf_len > memd->max_size)
              continue;
            if (av_len(av) >= arg)
              {
                /* exptime doesn't have to be defined.  */
                SV **ps = av_fetch(av, arg, 0);
                if (ps)
                  SvGETMAGIC(*ps);
                if (ps && SvOK(*ps))
                  exptime = SvIV(*ps);
              }

            if (ix != CMD_CAS)
              {
                client_prepare_set(memd->c, ix, i - 1, key, key_len, flags,
                                   exptime, buf, buf_len);
              }
            else
              {
                client_prepare_cas(memd->c, i - 1, key, key_len, cas, flags,
                                   exptime, buf, buf_len);
              }
          }
        client_execute(memd->c, 2);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key = *av_fetch((AV *) SvRV(ST(i + 1)), 0, 0);
                        HE *he = hv_store_ent(hv, key,
                                              SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1166 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 928 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, svalue_store, free_value, &value_res };
        const char *key;
        STRLEN key_len;
#line 1190 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 934 "Fast.xs"
        value_res.memd = memd;
        value_res.vals = NULL;
        client_reset(memd->c, &object, 0);
        key = SvPV(ST(1), key_len);
        client_prepare_get(memd->c, ix, 0, key, key_len);
        client_execute(memd->c, 2);
        if (value_res.vals)
          {
            PUSHs(sv_2mortal(value_res.vals));
            XSRETURN(1);
          }
        XSRETURN_EMPTY;
#line 1217 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_get_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_get_multi)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 955 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, mvalue_store, free_value, &value_res };
        int i, key_count;
        HV *hv;
#line 1241 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 961 "Fast.xs"
        key_count = items - 1;
        value_res.memd = memd;
        value_res.vals = (SV *) newAV();
        sv_2mortal(value_res.vals);
        av_extend((AV *) value_res.vals, key_count - 1);
        client_reset(memd->c, &object, 0);
        for (i = 0; i < key_count; ++i)
          {
            const char *key;
            STRLEN key_len;

            key = SvPV_stable_storage(aTHX_ ST(i + 1), &key_len);
            client_prepare_get(memd->c, ix, i, key, key_len);
          }
        client_execute(memd->c, 2);
        hv = newHV();
        for (i = 0; i <= av_len((AV *) value_res.vals); ++i)
          {
            SV **val = av_fetch((AV *) value_res.vals, i, 0);
            if (val && SvOK(*val))
              {
                SV *key = ST(i + 1);
                HE *he = hv_store_ent(hv, key,
                                      SvREFCNT_inc(*val), 0);
                if (! he)
                  SvREFCNT_dec(*val);
              }
          }
        PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
        XSRETURN(1);
#line 1286 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_gat); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_gat)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1000 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, svalue_store, free_value, &value_res };
        const char *key;
        STRLEN key_len;
        const char *exptime = "0";
        STRLEN exptime_len = 1;
        SV *sv;
#line 1313 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1009 "Fast.xs"
        value_res.memd = memd;
        value_res.vals = NULL;
        client_reset(memd->c, &object, 0);
        sv = ST(1);
        SvGETMAGIC(sv);
        if (SvOK(sv))
          exptime = SvPV(sv, exptime_len);
        key = SvPV(ST(2), key_len);
        client_prepare_gat(memd->c, ix, 0, key, key_len, exptime, exptime_len);
        client_execute(memd->c, 4);
        if (value_res.vals)
          {
            PUSHs(sv_2mortal(value_res.vals));
            XSRETURN(1);
          }
        XSRETURN_EMPTY;
#line 1344 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_gat_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_gat_multi)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1033 "Fast.xs"
        struct xs_value_result value_res;
        struct result_object object =
            { alloc_value, mvalue_store, free_value, &value_res };
        int i, key_count;
        HV *hv;
        SV *sv;
        const char *exptime = "0";
        STRLEN exptime_len = 1;
#line 1371 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1042 "Fast.xs"
        key_count = items - 2;
        value_res.memd = memd;
        value_res.vals = (SV *) newAV();
        sv_2mortal(value_res.vals);
        if (key_count > 1)
          av_extend((AV *) value_res.vals, key_count - 1);
        client_reset(memd->c, &object, 0);
        sv = ST(1);
        SvGETMAGIC(sv);
        if (SvOK(sv))
          exptime = SvPV(sv, exptime_len);
        for (i = 0; i < key_count; ++i)
          {
            const char *key;
            STRLEN key_len;
            key = SvPV_stable_storage(aTHX_ ST(i + 2), &key_len);
            client_prepare_gat(memd->c, ix, i, key, key_len, exptime, exptime_len);
          }
        client_execute(memd->c, 4);
        hv = newHV();
        for (i = 0; i <= av_len((AV *) value_res.vals); ++i)
          {
            SV **val = av_fetch((AV *) value_res.vals, i, 0);
            if (val && SvOK(*val))
              {
                SV *key = ST(i + 2);
                HE *he = hv_store_ent(hv, key,
                                      SvREFCNT_inc(*val), 0);
                if (! he)
                  SvREFCNT_dec(*val);
              }
          }
        PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
        XSRETURN(1);
#line 1420 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_incr); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_incr)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1085 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int noreply;
        const char *key;
        STRLEN key_len;
        arith_type arg = 1;
#line 1445 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1092 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV_stable_storage(aTHX_ ST(1), &key_len);
        if (items > 2)
          {
            /* increment doesn't have to be defined.  */
            SV *sv = ST(2);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              arg = SvUV(sv);
          }
        client_prepare_incr(memd->c, ix, 0, key, key_len, arg);
        client_execute(memd->c, 2);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
            XSRETURN_EMPTY;
          }
#line 1485 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_incr_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_incr_multi)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1126 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int i, noreply;
#line 1507 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1130 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            AV *av;
            const char *key;
            STRLEN key_len;
            arith_type arg = 1;

            sv = ST(i);
            if (! SvROK(sv))
              {
                key = SvPV_stable_storage(aTHX_ sv, &key_len);
              }
            else
              {
                if (SvTYPE(SvRV(sv)) != SVt_PVAV)
                  croak("Not an array reference");

                av = (AV *) SvRV(sv);
                key = SvPV_stable_storage(aTHX_ *safe_av_fetch(aTHX_ av, 0, 0), &key_len);
                if (av_len(av) >= 1)
                  {
                    /* increment doesn't have to be defined.  */
                    SV **ps = av_fetch(av, 1, 0);
                    if (ps)
                      SvGETMAGIC(*ps);
                    if (ps && SvOK(*ps))
                      arg = SvUV(*ps);
                  }
              }

            client_prepare_incr(memd->c, ix, i - 1, key, key_len, arg);
          }
        client_execute(memd->c, 2);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key;
                        HE *he;

                        key = ST(i + 1);
                        if (SvROK(key))
                          key = *av_fetch((AV *) SvRV(key), 0, 0);

                        he = hv_store_ent(hv, key, SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1600 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_delete)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1215 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int noreply;
        const char *key;
        STRLEN key_len;
#line 1623 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1221 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV_stable_storage(aTHX_ ST(1), &key_len);
        if (items > 2)
          {
            /* Compatibility with old (key, delay) syntax.  */

            /* delay doesn't have to be defined.  */
            SV *sv = ST(2);
            SvGETMAGIC(sv);
            if (SvOK(sv) && SvUV(sv) != 0)
              warn("non-zero delete expiration time is ignored");
          }
        client_prepare_delete(memd->c, 0, key, key_len);
        client_execute(memd->c, 2);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
            XSRETURN_EMPTY;
          }
#line 1665 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_delete_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_delete_multi)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1255 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int i, noreply;
#line 1686 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1259 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            const char *key;
            STRLEN key_len;

            sv = ST(i);
            if (! SvROK(sv))
              {
                key = SvPV_stable_storage(aTHX_ sv, &key_len);
              }
            else
              {
                /* Compatibility with old [key, delay] syntax.  */

                AV *av;

                if (SvTYPE(SvRV(sv)) != SVt_PVAV)
                  croak("Not an array reference");

                av = (AV *) SvRV(sv);
                key = SvPV_stable_storage(aTHX_ *safe_av_fetch(aTHX_ av, 0, 0), &key_len);
                if (av_len(av) >= 1)
                  {
                    /* delay doesn't have to be defined.  */
                    SV **ps = av_fetch(av, 1, 0);
                    if (ps)
                      SvGETMAGIC(*ps);
                    if (ps && SvOK(*ps) && SvUV(*ps) != 0)
                      warn("non-zero delete expiration time is ignored");
                  }
              }

            client_prepare_delete(memd->c, i - 1, key, key_len);
          }
        client_execute(memd->c, 2);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key;
                        HE *he;

                        key = ST(i + 1);
                        if (SvROK(key))
                          key = *av_fetch((AV *) SvRV(key), 0, 0);

                        he = hv_store_ent(hv, key, SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1781 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_touch); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_touch)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1346 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int noreply;
        const char *key;
        STRLEN key_len;
        exptime_type exptime = 0;
        SV *sv;
#line 1806 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1354 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        key = SvPV_stable_storage(aTHX_ ST(1), &key_len);
        if (items > 2)
          {
            /* exptime doesn't have to be defined.  */
            sv = ST(2);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              exptime = SvIV(sv);
          }
        client_prepare_touch(memd->c, 0, key, key_len, exptime);
        client_execute(memd->c, 2);
        if (! noreply)
          {
            SV **val = av_fetch(object.arg, 0, 0);
            if (val)
              {
                PUSHs(*val);
                XSRETURN(1);
              }
            XSRETURN_EMPTY;
          }
#line 1846 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_touch_multi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_touch_multi)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	Cache_Memcached_Fast *	memd;
#line 1386 "Fast.xs"
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int i, noreply;
#line 1867 "Fast.c"

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1390 "Fast.xs"
        object.arg = newAV();
        sv_2mortal((SV *) object.arg);
        noreply = (GIMME_V == G_VOID);
        client_reset(memd->c, &object, noreply);
        for (i = 1; i < items; ++i)
          {
            SV *sv;
            AV *av;
            const char *key;
            STRLEN key_len;
            exptime_type exptime = 0;
            int arg = 0;

            sv = ST(i);
            if (! (SvROK(sv) && SvTYPE(SvRV(sv)) == SVt_PVAV))
              croak("Not an array reference");

            av = (AV *) SvRV(sv);
            key = SvPV_stable_storage(aTHX_ *safe_av_fetch(aTHX_ av, arg, 0), &key_len);
            ++arg;

            if (av_len(av) >= 1)
              {
                /* exptime doesn't have to be defined.  */
                SV **ps = av_fetch(av, arg, 0);
                if (ps)
                  SvGETMAGIC(*ps);
                if (ps && SvOK(*ps))
                  exptime = SvIV(*ps);
              }

            client_prepare_touch(memd->c, i - 1, key, key_len, exptime);
          }
        client_execute(memd->c, 2);
        if (! noreply)
          {
            if (GIMME_V == G_SCALAR)
              {
                HV *hv = newHV();
                for (i = 0; i <= av_len(object.arg); ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val && SvOK(*val))
                      {
                        SV *key;
                        HE *he;

                        key = ST(i + 1);
                        if (SvROK(key))
                          key = *av_fetch((AV *) SvRV(key), 0, 0);

                        he = hv_store_ent(hv, key, SvREFCNT_inc(*val), 0);
                        if (! he)
                          SvREFCNT_dec(*val);
                      }
                  }
                PUSHs(sv_2mortal(newRV_noinc((SV *) hv)));
                XSRETURN(1);
              }
            else
              {
                I32 max_index = av_len(object.arg);
                EXTEND(SP, max_index + 1);
                for (i = 0; i <= max_index; ++i)
                  {
                    SV **val = av_fetch(object.arg, i, 0);
                    if (val)
                      PUSHs(*val);
                    else
                      PUSHs(&PL_sv_undef);
                  }
                XSRETURN(max_index + 1);
              }
          }
#line 1956 "Fast.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Cache__Memcached__Fast_flush_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_flush_all)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    {
	Cache_Memcached_Fast *	memd;
#line 1471 "Fast.xs"
        delay_type delay = 0;
        struct result_object object =
            { NULL, result_store, NULL, NULL };
        int noreply;
#line 1976 "Fast.c"
	HV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1476 "Fast.xs"
        RETVAL = newHV();
        /* Why sv_2mortal() is needed is explained in perlxs.  */
        sv_2mortal((SV *) RETVAL);
        object.arg = sv_2mortal((SV *) newAV());
        if (items > 1)
          {
            SV *sv = ST(1);
            SvGETMAGIC(sv);
            if (SvOK(sv))
              delay = SvUV(sv);
          }
        noreply = (GIMME_V == G_VOID);
        client_flush_all(memd->c, delay, &object, noreply);
        if (! noreply)
          {
            int i;
            for (i = 0; i <= av_len(object.arg); ++i)
              {
                SV **server = av_fetch(memd->servers, i, 0);
                SV **version = av_fetch(object.arg, i, 0);
                if (version && SvOK(*version))
                  {
                    HE *he = hv_store_ent(RETVAL, *server,
                                          SvREFCNT_inc(*version), 0);
                    if (! he)
                      SvREFCNT_dec(*version);
                  }
              }
          }
#line 2021 "Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cache__Memcached__Fast_nowait_push); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_nowait_push)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1514 "Fast.xs"
        client_nowait_push(memd->c);
#line 2056 "Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Cache__Memcached__Fast_server_versions); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_server_versions)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;
#line 1522 "Fast.xs"
        struct result_object object =
            { alloc_value, embedded_store, NULL, NULL };
        int i;
#line 2074 "Fast.c"
	HV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1526 "Fast.xs"
        RETVAL = newHV();
        /* Why sv_2mortal() is needed is explained in perlxs.  */
        sv_2mortal((SV *) RETVAL);
        object.arg = sv_2mortal((SV *) newAV());
        client_server_versions(memd->c, &object);
        for (i = 0; i <= av_len(object.arg); ++i)
          {
            SV **server = av_fetch(memd->servers, i, 0);
            SV **version = av_fetch(object.arg, i, 0);
            if (version && SvOK(*version))
              {
                HE *he = hv_store_ent(RETVAL, *server,
                                      SvREFCNT_inc(*version), 0);
                if (! he)
                  SvREFCNT_dec(*version);
              }
          }
#line 2107 "Fast.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cache__Memcached__Fast_namespace); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_namespace)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "memd, ...");
    {
	Cache_Memcached_Fast *	memd;
#line 1552 "Fast.xs"
        const char *ns;
        size_t len;
#line 2130 "Fast.c"
	SV *	RETVAL;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1555 "Fast.xs"
        ns = client_get_prefix(memd->c, &len);
        RETVAL = newSVpv(ns, len);
        if (items > 1)
          {
            ns = SvPV(ST(1), len);
            if (client_set_prefix(memd->c, ns, len) != MEMCACHED_SUCCESS)
              croak("Not enough memory");
          }
#line 2154 "Fast.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Cache__Memcached__Fast_disconnect_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast_disconnect_all)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "memd");
    {
	Cache_Memcached_Fast *	memd;

        /*
          We disable the derived check because it's kinda useless but
          slow.
        */
        if (1 || sv_derived_from(ST(0), "Cache::Memcached::Fast"))
          {
            IV tmp = SvIV((SV *) SvRV(ST(0)));
            memd = INT2PTR(Cache_Memcached_Fast *, tmp);
          }
        else
          croak("memd is not of type Cache::Memcached::Fast")
;
#line 1572 "Fast.xs"
        client_reinit(memd->c);
#line 2185 "Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Cache__Memcached__Fast__weaken); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Cache__Memcached__Fast__weaken)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 1580 "Fast.xs"
        sv_rvweaken(sv);
#line 2202 "Fast.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Cache__Memcached__Fast); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Cache__Memcached__Fast)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Cache::Memcached::Fast::_new", XS_Cache__Memcached__Fast__new, file, "$$");
        (void)newXSproto_portable("Cache::Memcached::Fast::_destroy", XS_Cache__Memcached__Fast__destroy, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::enable_compress", XS_Cache__Memcached__Fast_enable_compress, file, "$$");
        cv = newXSproto_portable("Cache::Memcached::Fast::add", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_ADD;
        cv = newXSproto_portable("Cache::Memcached::Fast::append", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_APPEND;
        cv = newXSproto_portable("Cache::Memcached::Fast::cas", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_CAS;
        cv = newXSproto_portable("Cache::Memcached::Fast::prepend", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_PREPEND;
        cv = newXSproto_portable("Cache::Memcached::Fast::replace", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = CMD_REPLACE;
        cv = newXSproto_portable("Cache::Memcached::Fast::set", XS_Cache__Memcached__Fast_set, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::add_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_ADD;
        cv = newXSproto_portable("Cache::Memcached::Fast::append_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_APPEND;
        cv = newXSproto_portable("Cache::Memcached::Fast::cas_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_CAS;
        cv = newXSproto_portable("Cache::Memcached::Fast::prepend_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_PREPEND;
        cv = newXSproto_portable("Cache::Memcached::Fast::replace_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = CMD_REPLACE;
        cv = newXSproto_portable("Cache::Memcached::Fast::set_multi", XS_Cache__Memcached__Fast_set_multi, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::get", XS_Cache__Memcached__Fast_get, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::gets", XS_Cache__Memcached__Fast_get, file, "$@");
        XSANY.any_i32 = CMD_GETS;
        cv = newXSproto_portable("Cache::Memcached::Fast::get_multi", XS_Cache__Memcached__Fast_get_multi, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::gets_multi", XS_Cache__Memcached__Fast_get_multi, file, "$@");
        XSANY.any_i32 = CMD_GETS;
        cv = newXSproto_portable("Cache::Memcached::Fast::gat", XS_Cache__Memcached__Fast_gat, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::gats", XS_Cache__Memcached__Fast_gat, file, "$@");
        XSANY.any_i32 = CMD_GATS;
        cv = newXSproto_portable("Cache::Memcached::Fast::gat_multi", XS_Cache__Memcached__Fast_gat_multi, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::gats_multi", XS_Cache__Memcached__Fast_gat_multi, file, "$@");
        XSANY.any_i32 = CMD_GATS;
        cv = newXSproto_portable("Cache::Memcached::Fast::decr", XS_Cache__Memcached__Fast_incr, file, "$@");
        XSANY.any_i32 = CMD_DECR;
        cv = newXSproto_portable("Cache::Memcached::Fast::incr", XS_Cache__Memcached__Fast_incr, file, "$@");
        XSANY.any_i32 = 0;
        cv = newXSproto_portable("Cache::Memcached::Fast::decr_multi", XS_Cache__Memcached__Fast_incr_multi, file, "$@");
        XSANY.any_i32 = CMD_DECR;
        cv = newXSproto_portable("Cache::Memcached::Fast::incr_multi", XS_Cache__Memcached__Fast_incr_multi, file, "$@");
        XSANY.any_i32 = 0;
        (void)newXSproto_portable("Cache::Memcached::Fast::delete", XS_Cache__Memcached__Fast_delete, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::delete_multi", XS_Cache__Memcached__Fast_delete_multi, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::touch", XS_Cache__Memcached__Fast_touch, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::touch_multi", XS_Cache__Memcached__Fast_touch_multi, file, "$@");
        (void)newXSproto_portable("Cache::Memcached::Fast::flush_all", XS_Cache__Memcached__Fast_flush_all, file, "$;$");
        (void)newXSproto_portable("Cache::Memcached::Fast::nowait_push", XS_Cache__Memcached__Fast_nowait_push, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::server_versions", XS_Cache__Memcached__Fast_server_versions, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::namespace", XS_Cache__Memcached__Fast_namespace, file, "$;$");
        (void)newXSproto_portable("Cache::Memcached::Fast::disconnect_all", XS_Cache__Memcached__Fast_disconnect_all, file, "$");
        (void)newXSproto_portable("Cache::Memcached::Fast::_weaken", XS_Cache__Memcached__Fast__weaken, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

